SuperStrict

Framework brl.glmax2d
Import brl.pngloader

Type TPanzer
	Field image:TImage
	Field rot:Float
	Field x:Float
	Field y:Float
	
	Function Add:TPanzer(x:Float, y:Float, rot:Float = 0.0)
		Local panzer:TPanzer	= New TPanzer
		panzer.image			= LoadAnimImage("panzer.png", 128, 128, 0, 36)
		MidHandleImage(panzer.image)
		panzer.x				= x
		panzer.y				= y
		panzer.rot				= rot
		
		Return panzer
	End Function
	
	Method Draw()
		Local frame:Int
		If Self.rot <= 0.0 Then Self.rot = 360.0
		If Self.rot > 0.0 Then frame = (Int(Self.rot) / 10) Mod 36 Else frame = 0
		DrawImage(Self.image, Self.x, Self.y, frame)
	End Method
	
	Method Move()
		Self.x:+ Sin(Self.rot) * 4.0
		Self.y:+ Cos(Self.rot) * -4.0
	End Method
	
	Method MoveY()
		
	End Method
End Type

Type TShoot
	Global _list:TList
	Field x:Float
	Field y:Float
	Field power:Float
	Field angle:Float
	
	Function Add:TShoot(x:Float, y:Float, angle:Float)
		Local shoot:TShoot = New TShoot
		If shoot._list = Null Then shoot._list = New TList
		shoot._list.AddLast(shoot)
		shoot.x		= x + (Sin(angle) * 64.0)
		shoot.y		= y + (Cos(angle) * -64.0)
				
		shoot.power	= 12.0
		shoot.angle	= angle
		
		Return shoot	
	End Function
	
	Method Update()
		For Local shoot:TShoot = EachIn Self._list
			DrawOval(shoot.x - 4.0, shoot.y - 4.0, 8.0, 8.0)
			
			shoot.x:+ Sin(shoot.angle) * shoot.power
			shoot.y:+ Cos(shoot.angle) * (0 - shoot.power)
			shoot.power:-0.1
			If shoot.power < 2.0 Then shoot.Kill()
		Next
	End Method
	
	Method Kill()
		Self._list.Remove(Self)
	End Method
End Type

Graphics 1024, 768
SetBlend ALPHABLEND
SetClsColor 60, 130, 50

Local panzer:TPanzer = TPanzer.Add(400, 300)
Local timer:Int = MilliSecs()
Local shoot:TShoot

Repeat
	Cls
	Local time:Int = MilliSecs()
		
	If time - timer > 30
		timer = time 
		If KeyDown(KEY_LEFT) Then panzer.rot = (panzer.rot - 10.0) Mod 360.0
		If KeyDown(KEY_RIGHT) Then panzer.rot= (panzer.rot + 10.0) Mod 360.0
		If KeyDown(KEY_UP) Then panzer.Move()
		If KeyHit(KEY_SPACE) Then shoot = TShoot.Add(panzer.x, panzer.y, panzer.rot)
		
		If shoot <> Null
			shoot.Update()
		EndIf
	End If
	panzer.Draw()
	
	DrawText String(panzer.rot), 2, 2
	Flip
Until KeyHit(KEY_ESCAPE) Or AppTerminate()

End